import { Component, Input, NgModule } from '@angular/core';
import { ReactiveFormsModule } from '@angular/forms';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ui-shared-form-control/ui-shared-form-control.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// import {LocaleService} from '@locale/services/locale.service';
class UiSharedFormControlComponent {
    constructor() {
        this.errorMessages = { invalidChars: 'There are some invalid characters',
            required: 'The field shoun\'t be empty',
            maxlength: 'The field text length is to long' };
        this.isRequired = false;
        this.controlType = 'text';
        this.showWarning = false;
        this.labelSize = '120px';
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        if (this.inputCtrl) {
            /** @type {?} */
            const ctrl = this.inputCtrl;
            this.inputCtrl.valueChanges
                .subscribe((/**
             * @return {?}
             */
            () => {
                /** @type {?} */
                const errors = Object.assign({}, this.controlErrorMessages, this.errorMessages);
                if (ctrl.invalid && Object.keys(ctrl.errors).length > 0) {
                    /** @type {?} */
                    const ctrlErrors = Object.keys(ctrl.errors);
                    /** @type {?} */
                    const foundErrors = Object.keys(errors).filter((/**
                     * @param {?} errKey
                     * @return {?}
                     */
                    errKey => {
                        return ctrlErrors.includes(errKey);
                    }));
                    if (foundErrors.length > 0) {
                        this.controlErrorMessage = errors[foundErrors[0]];
                    }
                }
            }));
        }
    }
}
UiSharedFormControlComponent.decorators = [
    { type: Component, args: [{
                selector: 'ui-shared-form-control',
                template: "<div class=\"form-group form-group-validation row validate form-component\" [formGroup]=\"parentForm\"\r\n     [ngStyle]=\"{'grid-template-columns': labelSize  + ' 1fr ',\r\n     '-ms-grid-columns': labelSize  + ' 1fr '}\"\r\n     [class.has-error]=\"inputCtrl && inputCtrl.invalid && inputCtrl.touched\">\r\n  <label [for]=\"controlName\" [title]=\"controlLabel\"\r\n         class=\"form-label control-label\">\r\n    <span class=\"text-ellipsis\">{{controlLabel}}</span>\r\n    <ng-content select=\"[label]\" class=\"form-control\"></ng-content>\r\n    <span *ngIf=\"isRequired\" class=\"form-control-validation\">&nbsp;*</span>\r\n  </label>\r\n  <div class=\"form-field\">\r\n    <ng-content  class=\"form-control\"></ng-content>\r\n    <input *ngIf=\"controlType != 'other'\" [type]=\"controlType\" class=\"form-control text-ellipsis\" [formControlName]=\"controlName\"  [id]=\"controlName\"\r\n           aria-describedby=\"control-error-help-block\" [ngClass]=\"{'show-warning': showWarning}\">\r\n    <div id=\"control-error-help-block\" class=\"help-block\" *ngIf=\"controlErrorMessage !== ''\"\r\n         [title]=\"controlErrorMessage\"\r\n         [ngClass]=\"{'visible': inputCtrl && inputCtrl.invalid && inputCtrl.touched}\">\r\n      <div class=\"error-icon icon-small-error\"></div>\r\n      <div>{{controlErrorMessage}}</div>\r\n    </div>\r\n    <div id=\"control-warning-help-block\" class=\"help-block no-top-margin\"\r\n         [title]=\"controlWarningMessage\"\r\n         [ngClass]=\"{'visible': showWarning && !(inputCtrl && inputCtrl.invalid && inputCtrl.touched)}\">\r\n      <div class=\"icon-warning\"></div>\r\n      <div>{{controlWarningMessage}}</div>\r\n    </div>\r\n  </div>\r\n</div>\r\n",
                styles: [".error-icon.visible,.icon-warning.visible{display:block;width:16px;margin-right:16px}.error-icon{color:#e5004c}.icon-warning{color:#ffb000}.form-component{display:grid;display:-ms-grid}.form-component label{grid-column:1;-ms-grid-column:1;padding-top:6px;padding-right:6px;display:flex;height:54px}.form-component label span:first-child{max-width:95%}.form-component label span:nth-child(2){max-width:5%;margin-left:-3px;margin-top:-2px;color:#e4254c}.form-component .form-field{grid-column:2;-ms-grid-column:2;font-size:16px;color:#000;font-family:Metric}.form-group.form-group-validation.row.validate{margin:0;height:54px}.form-group.form-group-validation.row.validate .has-error input[type=text]:focus:hover,.form-group.form-group-validation.row.validate.has-error input[type=text]:focus{border-color:#e5004c}.form-group.form-group-validation.row.validate input:focus.show-warning{border-color:#ffb000}.form-group.form-group-validation.row.validate div.help-block{margin-top:6px;margin-bottom:0;opacity:0;font-size:14px;line-height:1;font-weight:400;visibility:hidden;display:flex;height:0;transform:translateY(-10px);transition:120ms ease-in}.form-group.form-group-validation.row.validate div.help-block .error-icon,.form-group.form-group-validation.row.validate div.help-block .icon-warning{margin-right:4px;vertical-align:baseline;line-height:1;display:inline-block;font-style:normal}.form-group.form-group-validation.row.validate div.help-block.visible{opacity:1;height:100%;visibility:visible;transform:translateX(0);transition:120ms ease-in}.form-group.form-group-validation.row.validate div.help-block.visible.no-top-margin{margin-top:0}.text-ellipsis{overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.form-label{font-family:Metric,\"Helvetica Neue\",Helvetica,Arial,sans-serif;color:rgba(0,0,0,.56);font-size:16px;font-weight:400;opacity:1;max-width:100%;margin-bottom:5px}input[type=color],input[type=date],input[type=datetime-local],input[type=datetime],input[type=email],input[type=month],input[type=number],input[type=password],input[type=range],input[type=search],input[type=tel],input[type=text],input[type=time],input[type=url],input[type=week],select.form-control,textarea,textarea.form-control{height:32px;width:100%;line-height:16px;font-size:16px;color:#000;background-color:transparent;border:solid rgba(101,102,104,.64);border-radius:0;border-width:0 0 1px;padding:7px 0;box-shadow:none;box-sizing:border-box;margin-bottom:0;text-align:left;transition:border-color .15s ease-in-out,box-shadow .15s ease-in-out}input[type=color]:focus,input[type=date]:focus,input[type=datetime-local]:focus,input[type=datetime]:focus,input[type=email]:focus,input[type=month]:focus,input[type=number]:focus,input[type=password]:focus,input[type=range]:focus,input[type=search]:focus,input[type=tel]:focus,input[type=text]:focus,input[type=time]:focus,input[type=url]:focus,input[type=week]:focus,select.form-control:focus,textarea.form-control:focus,textarea:focus{border-color:#0073e7;box-shadow:unset;outline:0}"]
            }] }
];
/** @nocollapse */
UiSharedFormControlComponent.ctorParameters = () => [];
UiSharedFormControlComponent.propDecorators = {
    inputCtrl: [{ type: Input }],
    parentForm: [{ type: Input }],
    controlName: [{ type: Input }],
    controlLabel: [{ type: Input }],
    controlErrorMessages: [{ type: Input }],
    isRequired: [{ type: Input }],
    controlType: [{ type: Input }],
    showWarning: [{ type: Input }],
    controlWarningMessage: [{ type: Input }],
    labelSize: [{ type: Input }]
};
if (false) {
    /** @type {?} */
    UiSharedFormControlComponent.prototype.errorMessages;
    /** @type {?} */
    UiSharedFormControlComponent.prototype.inputCtrl;
    /** @type {?} */
    UiSharedFormControlComponent.prototype.parentForm;
    /** @type {?} */
    UiSharedFormControlComponent.prototype.controlName;
    /** @type {?} */
    UiSharedFormControlComponent.prototype.controlLabel;
    /** @type {?} */
    UiSharedFormControlComponent.prototype.controlErrorMessages;
    /** @type {?} */
    UiSharedFormControlComponent.prototype.isRequired;
    /** @type {?} */
    UiSharedFormControlComponent.prototype.controlType;
    /** @type {?} */
    UiSharedFormControlComponent.prototype.showWarning;
    /** @type {?} */
    UiSharedFormControlComponent.prototype.controlWarningMessage;
    /** @type {?} */
    UiSharedFormControlComponent.prototype.labelSize;
    /** @type {?} */
    UiSharedFormControlComponent.prototype.controlErrorMessage;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ui-components.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class UiComponentsModule {
}
UiComponentsModule.decorators = [
    { type: NgModule, args: [{
                declarations: [UiSharedFormControlComponent],
                imports: [
                    CommonModule,
                    ReactiveFormsModule
                ],
                exports: [UiSharedFormControlComponent]
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: microfocus-lre-ui-shared-components.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { UiComponentsModule, UiSharedFormControlComponent };
//# sourceMappingURL=microfocus-lre-ui-shared-components.js.map
